# GenInvoices

Generate any invoices that are due to be generated

### Request Parameters

| Parameter | Type | Description | Required |
|  --- | --- | --- | --- |
| action | string | "GenInvoices" | Required |
| noemails | bool | Stop any invoice created emails being sent | Optional |
| clientid | int | Pass to generate invoices only for a single client id | Optional |
| serviceids | int[] | An array of service ids to generate invoices for | Optional |
| domainids | int[] | An array of domain ids to generate invoices for | Optional |
| addonids | int[] | An array of addon ids to generate invoices for | Optional |


### Response Parameters

| Parameter | Type | Description |
|  --- | --- | --- |
| result | string | The result of the operation: success or error |
| numcreated | int | The number of invoices generated |
| latestinvoiceid | int | When generating for a specific client, the last invoice id generated. |


### Example Request (CURL)

```
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, 'https://www.example.com/includes/api.php');
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS,
    http_build_query(
        array(
            'action' => 'GenInvoices',
            // See https://developers.whmcs.com/api/authentication
            'username' => 'IDENTIFIER_OR_ADMIN_USERNAME',
            'password' => 'SECRET_OR_HASHED_PASSWORD',
            'responsetype' => 'json',
        )
    )
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
$response = curl_exec($ch);
curl_close($ch);
```

### Example Request (Local API)

```
$command = 'GenInvoices';
$postData = array(
);
$adminUsername = 'ADMIN_USERNAME'; // Optional for WHMCS 7.2 and later

$results = localAPI($command, $postData, $adminUsername);
print_r($results);
```

### Example Response JSON

```
{
    "result": "success",
    "numcreated": "3"
}
```

### Error Responses

Possible error condition responses include:

* Client ID Not Found


### Version History

| Version | Changelog |
|  --- | --- |
| 1.0 | Initial Version |